export default Collection;
declare class Collection {
    constructor(data?: any[], options?: {
        findBy?: Function;
        beforePush?: Function | Function[];
        afterPush?: Function | Function[];
        beforeDelete?: Function | Function[];
        afterDelete?: Function | Function[];
        beforeReplace?: Function | Function[];
        afterReplace?: Function | Function[];
        lock?: boolean;
    });
    findBy(key: any, array: any[]): any;
    readonly set items(value: any[]);
    readonly get items(): any[];
    readonly get lastIndex(): number;
    lock(): Collection;
    _locked: boolean;
    freeze(): Collection;
    unlock(): Collection;
    unfreeze(): Collection;
    isLocked(): boolean;
    abortIfLocked(): void;
    setItems(items: any[]): void;
    get(): any[];
    all(): any[];
    find(key: Function | number | string): any;
    findWithIndex(key: Function | number | string): any;
    filter(callbackFn: Function, thisArg?: any): any[];
    findMany(...args: any[]): Promise<Collection>;
    pushItem(item: any): Promise<Collection>;
    add(...args: any[]): Promise<Collection>;
    push(...args: any[]): Promise<Collection>;
    deleteItem(key: Function | number | string): Promise<Collection>;
    delete(...args: any[]): Promise<Collection>;
    replaceItem(key: Function | number | string, to: any): Promise<Collection>;
    replace(...args: any[]): Promise<Collection>;
    touch(...args: any[]): Promise<Collection>;
    update(...args: any[]): Promise<Collection>;
    upsertItem(key: Function | number | string, to: any): Promise<Collection>;
    upsert(...args: any[]): Promise<Collection>;
    map(...args: any[]): any[];
    reduce(...args: any[]): any[] | object;
    maxBy(sortFct: Function): any;
    minBy(sortFct: Function): any;
    orderBy(...args: any[]): any;
    sortBy(sortFct: Function): any;
    onBeforePush(func: Function | Function[]): void;
    onAfterPush(func: Function | Function[]): void;
    onBeforeDelete(func: Function | Function[]): void;
    onAfterDelete(func: Function | Function[]): void;
    onBeforeReplace(func: Function | Function[]): void;
    onAfterReplace(func: Function | Function[]): void;
    _items: any[];
    #private;
}
//# sourceMappingURL=Collection.d.ts.map